#pragma once

#define DLURLMAX 512

struct CAutoDLData
{
	TCHAR	sUrl[DLURLMAX];
	ULONG	ulInterval;	// in minutes
	long	lLastCheck;	// time() value
};

class CAutoDL : public CLoggable
{
public:
	CAutoDL();
	virtual ~CAutoDL();

	bool LoadPrefs();
	bool SavePrefs();

	void Restart(){ Start(); }

	__declspec(property(get=get_UseIt,put=put_UseIt))	bool UseIt;
	__declspec(property(get=get_UrlCount))				long UrlCount;
	__declspec(property(get=get_UrlItem))				CAutoDLData UrlItem[];

	bool get_UseIt();
	void put_UseIt(bool bUseIt);
	long get_UrlCount();
	CAutoDLData get_UrlItem(long nIndex);
	void ClearUrlList();
	void AddUrlItem(CAutoDLData& data);

private:
	static void WorkerThread(void *);
	void Start();
	void Finish();
	void GetConfigFilename(CString *pstrOut);
	ULONG CheckUrl(const TCHAR *pcUrl);
	void DownloadLink(CString sLink, CString sCategory);

private:
	HANDLE	m_hWorkerThread;
	HANDLE	m_hFinish;

	CArray<CAutoDLData, CAutoDLData> m_UrlList;
	bool	m_bUseIt;
};