#pragma once

#include "..\resource.h"
#include "..\PartFile.h"
#include "..\MuleListCtrl.h"

// CFDSrcNames dialog

enum EnumFDSrcNameListColumns
{
	FDSRCCOL_FILENAME = 0,
	FDSRCCOL_SOURCES,

	FDSRCCOL_NUMCOLUMNS
};

struct FCtrlItem_Struct
{
	CString	strFileName;
	uint32	iCount;
};

class CFDSrcNames : public CPropertyPage
{
	DECLARE_DYNCREATE(CFDSrcNames)

// Construction
public:
	CFDSrcNames();
	~CFDSrcNames();

	void Localize();
	void Update();

	CPartFile* m_pFile;

// Dialog Data
	//{{AFX_DATA(CFDSrcNames)
	enum { IDD = IDD_FDPPG_SOURCENAMES };
	CButton m_ctrlTakeOver;
	CButton m_ctrlCleanUp;
	CButton m_ctrlRename;
	CEdit m_ctrlFilename;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CFDSrcNames)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CFDSrcNames)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	static int CALLBACK CompareListNameItems(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
	virtual void OnOK();

	CMuleListCtrl	pmyListCtrl;

private:
	bool			m_bSortAscending[FDSRCCOL_NUMCOLUMNS];

	void FillSourcenameList();

public:
	afx_msg void OnLvnColumnclick(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMDblclkList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMRclickList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedRename();
	afx_msg void OnBnClickedCleanup();
	afx_msg void OnBnClickedFdsTakeover();
	afx_msg void OnDestroy();
	virtual BOOL OnCommand(WPARAM wParam,LPARAM lParam );
	virtual BOOL OnInitDialog();
};