// TaskProcessorDB.h: interface for the CTaskProcessor_DB class.
//
//////////////////////////////////////////////////////////////////////

#pragma once

//#include "../../Loggable.h"
#include "../../Engine/TaskProcessor.h"
//#include "../BerkeleyDb/build_win32/db_cxx.h"

class Db;
class DbEnv;

struct CTask_AddToLog : public CTask
{
	CTask_AddToLog(DbEnv *pDbEnv, Db *pDb, BOOL bDebug, LPCTSTR sLine);
	virtual bool Process();
	virtual LPCTSTR TaskName(){ return _T("AddToLog"); }

	long	m_lTime;
	BOOL	m_bDebug;
	CString	m_sLine;

	DbEnv	*m_pDbEnv;
	Db		*m_pDb;
};

class CTaskProcessor_DB : public CTaskProcessor
{
	virtual bool Start();
	virtual void Stop();
	virtual void ProcessTimeout();

public:
	CTaskProcessor_DB();
	virtual ~CTaskProcessor_DB();

	__declspec(property(get=_GetLogs)) Db& Logs;

	Db&	_GetLogs(){ if(!m_pDbLogs) throw; return *m_pDbLogs; }

private:
	DbEnv	*m_pDbEnv;		// Database environment
	Db		*m_pDbLogs;		// Logs DB

//	Db		*m_pDbServers;	// Servers list DB
//	Db		*m_pDbFiles;	// Files DB
//	Db		*m_pDbMD4Parts;	// Parts DB (for standard ed2k with MD4)

	friend class CLoggable;
};

