// XML.h: helper class.
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "../TaskProcessor.h"
#include "../Other/XMLhelper.h"

enum
{
	XML_GET_START	= 0,
	XML_GET_READ	= 1,
	XML_GET_SEND	= 2
};

class CXmlTask : public CTcpCompletionTask
{
public:
	CXmlTask();
	virtual bool LoadParams(XmlElement spElem) = 0;
	virtual XmlDoc PrepareResult();

	void SendBuf(CString sXml);

	static CXmlTask* ParseXml(CString sXml);

	ULONG	GetId(){ return m_ulId; }

	void SetClient(CEmClient_Xml *pClient){ m_pClient = pClient; }

	// for debug
	void SetReceived(bool bReceived){ m_bReceived = bReceived; }

protected:
	ULONG	m_ulId;
	bool	m_bReceived;
	bool	m_bResult;

	CEmClient_Xml *m_pClient;

	CString	m_sName;

	CString m_sContents;

	static long	s_lNextId;
};

// Defining Xml task classes
#define BEGIN_XML_CMD(name)		class CXml_##name : public CXmlTask \
									{ \
									public: \
									CXml_##name(); \
									virtual bool Process(); \
									bool ProcessResult(); \
									bool ProcessReceived(); \
									virtual void SetClient(CEmClient *pClient) { m_pClient = dynamic_cast<CEmClient_Xml*>(pClient); } \
									bool LoadParams(XmlElement spElem); \
									virtual LPCTSTR TaskName(){ return _T(#name); } \

#define XML_PARAM_STRING(var)		CString m_s##var;
#define XML_PARAM_ULONG(var)		ULONG m_ul##var;
#define XML_INTERNAL_VAR(var,init)	var;
#define END_XML_CMD				};
#include "XMLMsgs.h"

#define XML_PROCESS_FUNC(name)	bool CXml_##name::ProcessReceived()
#define XML_RESULT_FUNC(name)	bool CXml_##name::ProcessResult()
