// Apfelteig Patch ;-)

#include "stdafx.h"
#include "emule.h"
#include "otherfunctions.h"
#include "PPgSMTP.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CPPgSMTP, CPropertyPage)
CPPgSMTP::CPPgSMTP()
	: CPropertyPage(CPPgSMTP::IDD)
	, SMTPServer(_T(""))
	, SMTPName(_T(""))
	, SMTPFrom(_T(""))
	, SMTPTo(_T(""))
	, SMTPUserName(_T(""))
	, SMTPPassword(_T(""))
	, SMTPAuthenticated(FALSE)
	, SMTPInfoEnabled(FALSE)
	, SMTPWarningEnabled(FALSE)
	, SMTPServerDesc(_T(""))
	, SMTPNameDesc(_T(""))
	, SMTPFromDesc(_T(""))
	, SMTPToDesc(_T(""))
	, SMTPUserNameDesc(_T(""))
	, SMTPPasswordDesc(_T(""))
	, SMTPAuthenticationFrame(_T(""))
{
}

CPPgSMTP::~CPPgSMTP()
{
}

void CPPgSMTP::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_SMTPSERVER, SMTPServer);
	DDX_Text(pDX, IDC_SMTPNAME, SMTPName);
	DDX_Text(pDX, IDC_SMTPFROM, SMTPFrom);
	DDX_Text(pDX, IDC_SMTPTO, SMTPTo);
	DDX_Text(pDX, IDC_SMTPUSERNAME, SMTPUserName);
	DDX_Text(pDX, IDC_SMTPPASSWORD, SMTPPassword);
	DDX_Check(pDX, IDC_SMTPAUTHENTICATED, SMTPAuthenticated);
	DDX_Check(pDX, IDC_SMTPINFOENABLED, SMTPInfoEnabled);
	DDX_Check(pDX, IDC_SMTPWARNINGENABLED, SMTPWarningEnabled);
	DDX_Control(pDX, IDC_SMTPSERVER, SMTPServerEdit);
	DDX_Control(pDX, IDC_SMTPNAME, SMTPNameEdit);
	DDX_Control(pDX, IDC_SMTPFROM, SMTPFromEdit);
	DDX_Control(pDX, IDC_SMTPTO, SMTPToEdit);
	DDX_Control(pDX, IDC_SMTPUSERNAME, SMTPUserNameEdit);
	DDX_Control(pDX, IDC_SMTPPASSWORD, SMTPPasswordEdit);
	DDX_Control(pDX, IDC_SMTPAUTHENTICATED, SMTPAuthenticatedCheck);
	DDX_Control(pDX, IDC_SMTPINFOENABLED, SMTPInfoEnabledCheck);
	DDX_Control(pDX, IDC_SMTPWARNINGENABLED, SMTPWarningEnabledCheck);
	DDX_Text(pDX, IDC_SMTPSERVER_LBL, SMTPServerDesc);
	DDX_Text(pDX, IDC_SMTPNAME_LBL, SMTPNameDesc);
	DDX_Text(pDX, IDC_SMTPFROM_LBL, SMTPFromDesc);
	DDX_Text(pDX, IDC_SMTPTO_LBL, SMTPToDesc);
	DDX_Text(pDX, IDC_SMTPUSERNAME_LBL, SMTPUserNameDesc);
	DDX_Text(pDX, IDC_SMTPPASSWORD_LBL, SMTPPasswordDesc);
	DDX_Text(pDX, IDC_SMTPAUTHENTICATION_FRM, SMTPAuthenticationFrame);
}

BEGIN_MESSAGE_MAP(CPPgSMTP, CPropertyPage)
	ON_EN_CHANGE(IDC_SMTPSERVER, OnDataChange)
	ON_EN_CHANGE(IDC_SMTPNAME, OnDataChange)
	ON_EN_CHANGE(IDC_SMTPFROM, OnDataChange)
	ON_EN_CHANGE(IDC_SMTPTO, OnDataChange)
	ON_EN_CHANGE(IDC_SMTPUSERNAME, OnDataChange)
	ON_EN_CHANGE(IDC_SMTPPASSWORD, OnDataChange)
	ON_BN_CLICKED(IDC_SMTPAUTHENTICATED, OnEnChangeSMTPAuthenticated)
	ON_BN_CLICKED(IDC_SMTPINFOENABLED, OnDataChange)
	ON_BN_CLICKED(IDC_SMTPWARNINGENABLED, OnDataChange)
END_MESSAGE_MAP()

BOOL CPPgSMTP::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgSMTP::LoadSettings(void)
{	
	SMTPServer = m_pPrefs->GetSMTPServer();
	SMTPName = m_pPrefs->GetSMTPName();
	SMTPFrom = m_pPrefs->GetSMTPFrom();
	SMTPTo = m_pPrefs->GetSMTPTo();
	SMTPUserName = m_pPrefs->GetSMTPUserName();
	SMTPPassword = Decrypt(m_pPrefs->GetSMTPPassword());
	
	SMTPAuthenticated = m_pPrefs->IsSMTPAuthenticated();
	SMTPInfoEnabled = m_pPrefs->IsSMTPInfoEnabled();
	SMTPWarningEnabled = m_pPrefs->IsSMTPWarningEnabled();

	UpdateData(FALSE);

	OnEnChangeSMTPAuthenticated();

	SetModified(FALSE);	// FoRcHa
}

BOOL CPPgSMTP::OnApply()
{	
	if(m_bModified)
	{
		UpdateData(TRUE);
		
		if(!SMTPServer.IsEmpty())
			m_pPrefs->SetSMTPServer(SMTPServer);
		if(!SMTPName.IsEmpty())
			m_pPrefs->SetSMTPName(SMTPName);
		if(!SMTPFrom.IsEmpty())
			m_pPrefs->SetSMTPFrom(SMTPFrom);
		if(!SMTPTo.IsEmpty())
			m_pPrefs->SetSMTPTo(SMTPTo);
		if(!SMTPUserName.IsEmpty())
			m_pPrefs->SetSMTPUserName(SMTPUserName);
		if(!SMTPPassword.IsEmpty())
			m_pPrefs->SetSMTPPassword(Crypt(SMTPPassword));

		m_pPrefs->SetSMTPAuthenticated(SMTPAuthenticated);
		m_pPrefs->SetSMTPInfoEnabled(SMTPInfoEnabled);
		m_pPrefs->SetSMTPWarningEnabled(SMTPWarningEnabled);

		UpdateData(FALSE);

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgSMTP::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{

		SetWindowText(GetResString(IDS_PW_SMTP));
		GetResString(&SMTPAuthenticationFrame, IDS_AUTHENTICATION);
		GetResString(&SMTPServerDesc, IDS_PW_SERVER);
		GetResString(&SMTPNameDesc, IDS_SW_NAME);
		GetResString(&SMTPFromDesc, IDS_FROM);
		GetResString(&SMTPToDesc, IDS_TO);
		GetResString(&SMTPUserNameDesc, IDS_PROXY_USERNAME);
		GetResString(&SMTPPasswordDesc, IDS_PASSWORD);
		SMTPAuthenticatedCheck.SetWindowText(GetResString(IDS_ENABLED));
		SMTPInfoEnabledCheck.SetWindowText(GetResString(IDS_SMTPMSG_INFO));
		SMTPWarningEnabledCheck.SetWindowText(GetResString(IDS_SMTPMSG_WARNING));

		UpdateData(FALSE);
	}
}

void CPPgSMTP::OnEnChangeSMTPAuthenticated()
{
	UpdateData(TRUE);

	SMTPUserNameEdit.EnableWindow(SMTPAuthenticated);
	SMTPPasswordEdit.EnableWindow(SMTPAuthenticated);

	SetModified();
}
