//--- xrmb:parttraffic ---
//--- there are so many changes in here, maybe its easier to exchange the whole file ---

//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h"
#include "emule.h"
#include "SharedFilesCtrl.h"
#include "otherfunctions.h"
#include "CommentDialog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//--- minimum repaint time for a trafficbar (ms) ---
#define SFL_BARUPDATE 1000

#define sortcmp(a, b) ((a)==(b))?0: (((a)<(b))?-1:1)

#define GrayIt(gray, color) gray?(0x444444+0x010101*((GetRValue(color)*30+GetGValue(color)*59+GetBValue(color)*11)/0xFF)):color

IMPLEMENT_DYNAMIC(CSharedFilesCtrl, CMuleListCtrl)

BEGIN_MESSAGE_MAP(CSharedFilesCtrl, CMuleListCtrl)
	ON_WM_CONTEXTMENU()
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDoubleClick)
	ON_NOTIFY_REFLECT(NM_CLICK, OnNMClick)
	ON_NOTIFY_REFLECT(LVN_GETDISPINFO, OnGetDispInfo)
END_MESSAGE_MAP()

//--- static members ---
byte	CSharedFilesCtrl::m_p2p[8];
bool	CSharedFilesCtrl::m_sortParts=false;

CSharedFilesCtrl::CSharedFilesCtrl() : m_pSCM(NULL)
{
	EMULE_TRY

	m_statusWidth = -1;

	SetColoring(0);
	SetDisplay(0, false);

	SetGeneralPurposeFind(true);

	m_allYaKnow = false;

	m_listSorter.init(SFL_NUMCOLUMNS);

	m_listSorter.item(SFL_COLUMN_FILESIZE)->set(1, true);
	m_listSorter.item(SFL_COLUMN_PRIORITY)->set(1, true);
	m_listSorter.item(SFL_COLUMN_REQUESTS)->set(2, true);
	m_listSorter.item(SFL_COLUMN_ACCEPTED)->set(2, true);
	m_listSorter.item(SFL_COLUMN_TRANSFERRED)->set(2, true);
	m_listSorter.item(SFL_COLUMN_PARTTRAFFIC)->set(2, true);
	m_listSorter.item(SFL_COLUMN_UPLOADS)->set(2, true);
	m_listSorter.item(SFL_COLUMN_COMPLETESRC)->set(2,true);
	m_listSorter.item(SFL_COLUMN_FOLDER)->set(1,true);

	//--- fast prio 2 prio converter, need because the prios are messed up a little bit ---
	m_p2p[PR_VERYLOW]	= 0;
	m_p2p[PR_LOW]		= 1;
	m_p2p[PR_NORMAL]	= 2;
	m_p2p[PR_HIGH]		= 3;
	m_p2p[PR_RELEASE]	= 4;
	m_p2p[PR_AUTO]		= 5;
	m_p2p[PR_JUMPSTART]	= 6;

	EMULE_CATCH
}

CSharedFilesCtrl::~CSharedFilesCtrl()
{
	if (m_pSCM)
		delete m_pSCM;

	m_imageList.DeleteImageList();
}

void CSharedFilesCtrl::Init()
{
	static const uint16 s_auIconResID[] =
	{
		IDI_RATING_NO,
		IDI_RATING_FAKE,
		IDI_RATING_POOR,
		IDI_RATING_GOOD,
		IDI_RATING_FAIR,
		IDI_RATING_EXCELLENT,
		IDI_RATING_NONE
	};
	static const uint16 s_auColHdr[][2] =
	{
		{ LVCFMT_LEFT,  250 },	//SFL_COLUMN_FILENAME
		{ LVCFMT_RIGHT, 100 },	//SFL_COLUMN_FILESIZE
		{ LVCFMT_LEFT,   50 },	//SFL_COLUMN_TYPE
		{ LVCFMT_LEFT,   70 },	//SFL_COLUMN_PRIORITY
		{ LVCFMT_LEFT,  100 },	//SFL_COLUMN_PERMISSION
		{ LVCFMT_LEFT,  220 },	//SFL_COLUMN_FILEID
		{ LVCFMT_LEFT,  100 },	//SFL_COLUMN_REQUESTS
		{ LVCFMT_LEFT,  100 },	//SFL_COLUMN_ACCEPTED
		{ LVCFMT_LEFT,  120 },	//SFL_COLUMN_TRANSFERRED
		{ LVCFMT_LEFT,  120 },	//SFL_COLUMN_PARTTRAFFIC
		{ LVCFMT_LEFT,  120 },	//SFL_COLUMN_UPLOADS
		{ LVCFMT_LEFT,  100 },	//SFL_COLUMN_COMPLETESRC
		{ LVCFMT_LEFT,  150 }	//SFL_COLUMN_FOLDER
	};

	EMULE_TRY

	SetColoring(g_eMuleApp.m_pGlobPrefs->GetUpbarColor());
	SetDisplay(g_eMuleApp.m_pGlobPrefs->GetUpbarStyle(), false);

	//--- that seems to be the way to make taller item :) (i hate mfc... honestly i don't understand mfc :) ---
	CImageList ilDummyImageList;
	ilDummyImageList.Create(1, 17, ILC_COLOR, 1, 1);
	SetImageList(&ilDummyImageList, LVSIL_SMALL);

	SetExtendedStyle(LVS_EX_FULLROWSELECT);
	ModifyStyle(LVS_SINGLESEL,0);

	//--- in the official emule source the is a unlogical value at the end (for me :) ---
	for (unsigned ui = 0; ui < ELEMENT_COUNT(s_auColHdr); ui++)
		InsertColumn(ui, _T(""), static_cast<int>(s_auColHdr[ui][0]), static_cast<int>(s_auColHdr[ui][1]));

	m_imageList.Create(16, 16, g_eMuleApp.m_iDfltImageListColorFlags | ILC_MASK, ELEMENT_COUNT(s_auIconResID), 0);
	m_imageList.SetBkColor(CLR_NONE);
	FillImgLstWith16x16Icons(&m_imageList, s_auIconResID, ELEMENT_COUNT(s_auIconResID));

	LoadSettings(CPreferences::TABLE_SHARED);

	if (g_eMuleApp.m_pGlobPrefs->DoUseSort())
	{
		SortInit(g_eMuleApp.m_pGlobPrefs->GetFileSortCol());
	}
	else
	{
		uint32		dwSortCode = g_eMuleApp.m_pGlobPrefs->GetColumnSortItem(CPreferences::TABLE_SHARED);

		dwSortCode |= g_eMuleApp.m_pGlobPrefs->GetColumnSortAscending(CPreferences::TABLE_SHARED) ? MLC_SORTASC : MLC_SORTDESC;

		SortInit(dwSortCode);
	}

	EMULE_CATCH
}

void CSharedFilesCtrl::SortInit(int iSortCode)
{
	EMULE_TRY

//get the sort column
	int		iSortColumn = (iSortCode & MLC_COLUMNMASK);
//get sort order
	bool	bSortAscending = (iSortCode & MLC_SORTDESC) == 0;
// check alternative order
	bool	bSortAlt = (iSortCode & MLC_SORTALT) != 0;

	SetSortArrow(iSortColumn, bSortAscending);
	m_listSorter.clicked(iSortColumn);
	m_listSorter.item(iSortColumn)->sortIt(bSortAlt ? 2:1, bSortAscending);
//	AddLogLine(true, "sort column %i, direction %s, level %i bSortDesc is: %i", m_listSorter.selected(), m_listSorter.dir()?"ascending":"descending", m_listSorter.level(),bReverse);
	SortItems(SortProc, (LPARAM)&m_listSorter);

	EMULE_CATCH
}

void CSharedFilesCtrl::Localize()
{
	static const uint16 s_auResTbl[] =
	{
		IDS_DL_FILENAME,	//SFL_COLUMN_FILENAME
		IDS_DL_SIZE,		//SFL_COLUMN_FILESIZE
		IDS_TYPE,			//SFL_COLUMN_TYPE
		IDS_PRIORITY,		//SFL_COLUMN_PRIORITY
		IDS_PERMISSION,		//SFL_COLUMN_PERMISSION
		IDS_FILEHASH,		//SFL_COLUMN_FILEID
		IDS_SF_REQUESTS,	//SFL_COLUMN_REQUESTS
		IDS_SF_ACCEPTS,		//SFL_COLUMN_ACCEPTED
		IDS_SF_TRANSFERRED,	//SFL_COLUMN_TRANSFERRED
		IDS_SF_PARTTRAFFIC,	//SFL_COLUMN_PARTTRAFFIC
		IDS_SF_COLUPLOADS,	//SFL_COLUMN_UPLOADS
		IDS_SF_COMPLETESRC,	//SFL_COLUMN_COMPLETESRC
		IDS_SF_FOLDER		//SFL_COLUMN_FOLDER
	};

	EMULE_TRY

	if (GetSafeHwnd())
	{
		CHeaderCtrl	*pHeaderCtrl = GetHeaderCtrl();
		CString		strRes;
		HDITEM		hdi;

		hdi.mask = HDI_TEXT;

		for (unsigned ui = 0; ui < ELEMENT_COUNT(s_auResTbl); ui++)
		{
			::GetResString(&strRes, static_cast<UINT>(s_auResTbl[ui]));
			hdi.pszText = (LPSTR)strRes.GetString();
			pHeaderCtrl->SetItem(static_cast<int>(ui), &hdi);
		}

	// Localization
		if(m_allYaKnow)
		{
			ShowKnownList();
		}
		else
		{
			ShowFileList(g_eMuleApp.m_pSharedFilesList);
		}
	}

	EMULE_CATCH
}

void CSharedFilesCtrl::ShowFileList(CSharedFileList* in_sflist)
{
	EMULE_TRY

	SetRedraw(FALSE);

	DeleteAllItems();
	CCKey bufKey;
	CKnownFile* cur_file;
	for(POSITION pos = in_sflist->m_mapSharedFiles.GetStartPosition(); pos != NULL;)
	{
		in_sflist->m_mapSharedFiles.GetNextAssoc(pos, bufKey, cur_file);
		ShowFile(cur_file, false);
	}

	m_allYaKnow = false;

	ShowFilesCount();
	g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.SetDlgItemText(IDC_BN_SWITCHALLKNOWN, GetResString(IDS_SF_SHOWALLKF));

	SetRedraw(TRUE);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSharedFilesCtrl::ShowKnownList()
{
	EMULE_TRY

	CKnownFileList* list=g_eMuleApp.m_pKnownFilesList;

	SetRedraw(FALSE);

	DeleteAllItems();

	uint32 records=list->GetCount();

	m_allYaKnow = true;

	for(uint32 i=0; i < records; i++)
	{
		CKnownFile* pKnownFile = list->ElementAt(i);
		if (pKnownFile)
		{
			ShowFile(pKnownFile, false);
		}
	}
	ShowFilesCount();
	g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.SetDlgItemText(IDC_BN_SWITCHALLKNOWN, GetResString(IDS_SF_SHOWALLSF));

	SetRedraw(TRUE);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSharedFilesCtrl::UpdateFile(CKnownFile* pSharedFile, uint32 itemnr, bool resort)
{
	if (!g_eMuleApp.m_pdlgEmule->IsRunning() || (pSharedFile == NULL))
		return;

	EMULE_TRY

	SetItemText(itemnr, SFL_COLUMN_FILESIZE, CastItoXBytes(pSharedFile->GetFileSize()));
	SetItemText(itemnr, SFL_COLUMN_TYPE, pSharedFile->GetFileTypeString(true));
	SetItemText(itemnr, SFL_COLUMN_PRIORITY, GetKnownFilePriorityString(pSharedFile));
	SetItemText(itemnr, SFL_COLUMN_PERMISSION, pSharedFile->GetPermissionString());
	SetItemText(itemnr, SFL_COLUMN_FILEID, HashToString(pSharedFile->GetFileHash()));

	CString	strBuffer;
	uint64	a = pSharedFile->statistic.GetRequests();
	uint64	b = pSharedFile->statistic.GetAllTimeRequests();

	if (a != 0 || b != 0)
		strBuffer.Format(_T("%I64u (%I64u)"), a, b);
	else
		strBuffer = _T("");
	SetItemText(itemnr, SFL_COLUMN_REQUESTS, strBuffer);

	a = pSharedFile->statistic.GetAccepts();
	b = pSharedFile->statistic.GetAllTimeAccepts();
	if (a != 0 || b != 0)
		strBuffer.Format(_T("%I64u (%I64u)"), a, b);
	else
		strBuffer = _T("");
	SetItemText(itemnr, SFL_COLUMN_ACCEPTED, strBuffer);

	a = pSharedFile->statistic.GetTransferred();
	b = pSharedFile->statistic.GetAllTimeTransferred();
	if (a != 0 || b != 0)
	{
		strBuffer.Format(_T("%s (%s)"), CastItoXBytes(a), CastItoXBytes(b));
	}
	else
		strBuffer = _T("");
	SetItemText(itemnr, SFL_COLUMN_TRANSFERRED, strBuffer);

	//--- upload column text, or no text if 0 ---
	a = pSharedFile->GetFileSize();
	b = pSharedFile->statistic.GetAllTimeTransferred();

	double	cr = pSharedFile->statistic.GetCompleteReleases();

	if (a != 0 && (cr + b != 0.0))
		strBuffer.Format(_T("%0.2f (%0.2f)"), cr, (double)b/a);
	else
		strBuffer = _T("");
	SetItemText(itemnr, SFL_COLUMN_UPLOADS, strBuffer);

	SetItemText(itemnr, SFL_COLUMN_FOLDER, pSharedFile->GetPath());

	//--- kids/parts open? ---
	sfl_itemdata* itemdataParent=(sfl_itemdata*)GetItemData(itemnr);
	if(itemdataParent->isOpen)
	{
		//--- update all parts ---
		for (uint16 part=0; part < itemdataParent->parts; part++)
		{
			int				iSubItemIdx = itemnr + 1 + part;
			sfl_itemdata	*itemdata=(sfl_itemdata*)GetItemData(iSubItemIdx);

			if (pSharedFile->IsPartShared(itemdata->part))
				  SetItemText(iSubItemIdx, SFL_COLUMN_PRIORITY, _T(""));
			else
				  SetItemText(iSubItemIdx, SFL_COLUMN_PRIORITY, GetResString(IDS_HIDDEN));

			//--- column size (completed part?) ---
			if (pSharedFile->IsPartFile() && (((CPartFile*)pSharedFile)->GetRemainingBlocksInPart(itemdata->part) != 0))
				SetItemText(iSubItemIdx, SFL_COLUMN_FILESIZE, _T(""));
			else
				SetItemText(iSubItemIdx, SFL_COLUMN_FILESIZE, _T("*"));

			//--- column accepted ---
			uint32	as = pSharedFile->statistic.GetPartAccepted(itemdata->part, true);
			uint32	a = pSharedFile->statistic.GetPartAccepted(itemdata->part, false);
			if (as != 0 || a != 0)
				strBuffer.Format(_T("%u (%u)"), as, a);
			else
				strBuffer = _T("");
			SetItemText(iSubItemIdx, SFL_COLUMN_ACCEPTED, strBuffer);

			//--- column transferred ---
			uint32 ts = pSharedFile->GetPartTraffic(itemdata->part, true);
			uint32 t = pSharedFile->GetPartTraffic(itemdata->part);
			if (ts != 0 || t != 0)
			{
				strBuffer.Format(_T("%s (%s)"), CastItoXBytes(ts), CastItoXBytes(t));
			}
			else
				strBuffer = _T("");
			SetItemText(iSubItemIdx, SFL_COLUMN_TRANSFERRED, strBuffer);

			//--- column complete releases ---
			double	cr = pSharedFile->statistic.GetCompletePartReleases(itemdata->part);
			if (ts != 0 || cr != 0.0)
				strBuffer.Format(_T("%0.2f (%0.2f)"), cr, (double)t/pSharedFile->GetPartSize(itemdata->part));
			else
				strBuffer = _T("");
			SetItemText(iSubItemIdx, SFL_COLUMN_UPLOADS, strBuffer);
		}
	}

	if (pSharedFile->IsPartFile())
	{
		strBuffer.Format(_T("%u"), ((CPartFile*)pSharedFile)->GetCompleteSourcesCount());
	}
	else
	{
		uint16 nCompleteSourcesCountLo, nCompleteSourcesCountHi;
		pSharedFile->GetCompleteSourcesRange(&nCompleteSourcesCountLo, &nCompleteSourcesCountHi);
		if (nCompleteSourcesCountLo == 0)
		{
			if (nCompleteSourcesCountHi == 0)
				strBuffer= _T("");
			else
				strBuffer.Format(_T("< %u"), nCompleteSourcesCountHi);
		}
		else if (nCompleteSourcesCountLo == nCompleteSourcesCountHi)
			strBuffer.Format(_T("%u"), nCompleteSourcesCountLo);
		else
			strBuffer.Format(_T("%u - %u"), nCompleteSourcesCountLo, nCompleteSourcesCountHi);
	}
	SetItemText(itemnr,SFL_COLUMN_COMPLETESRC,strBuffer);

	//--- good time for a resort ---

	//	MOREVIT - Ok, a little kludgy but this should prevent resorts during extended selection
	//		causing the selection to be cleared.
	bool	isShift = GetAsyncKeyState(VK_SHIFT) < 0;

	if (resort && !isShift)
		SortItems(SortProc, (LPARAM)&m_listSorter);

	EMULE_CATCH
}

void CSharedFilesCtrl::AddFile(CKnownFile *file)
{
	ShowFile(file);
	ShowFilesCount();
}

void CSharedFilesCtrl::ShowFile(CKnownFile* file, bool resort)
{
	ShowFile(file, GetItemCount(), resort);
}

void CSharedFilesCtrl::ShowFile(CKnownFile* file, uint32 itemnr, bool resort)
{
	EMULE_TRY

	if(file == NULL)
		return;

	sfl_itemdata	*itemdata = new sfl_itemdata;

	itemdata->isFile = true;
	itemdata->isOpen = false;
	itemdata->knownFile = file;
	itemdata->part = 0;
	itemdata->parts = 0;

	itemnr=InsertItem(LVIF_TEXT|LVIF_PARAM, itemnr, LPSTR_TEXTCALLBACK, 0, 0, 0, (LPARAM)itemdata);
	UpdateFile(file, itemnr, resort);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSharedFilesCtrl::RemoveFile(CKnownFile *toRemove)
{
	EMULE_TRY

	if(toRemove == NULL)
		return;

	sfl_itemdata*	itemdata;
	for(int nItem=0; nItem<GetItemCount(); nItem++)
	{
		itemdata=(sfl_itemdata*)GetItemData(nItem);
		if(itemdata->isFile && itemdata->knownFile==toRemove)
		{
			//--- delete all part-childs ---
			if(itemdata->isOpen)
			{
				for(uint16 part=0; part<itemdata->parts; part++)
				{
					sfl_itemdata	*itemdataPart=(sfl_itemdata*)GetItemData(nItem+1);

					if (itemdataPart->isFile)
						break;	//Cax2 14/01/03	bugfix
					SetItemData(nItem+1, NULL);
					DeleteItem(nItem+1);
					if(itemdataPart) delete itemdataPart;
				}
			}

			SetItemData(nItem, NULL);
			DeleteItem(nItem);
			if(itemdata) delete itemdata;
		}
	}
	ShowFilesCount();

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CSharedFilesCtrl::DeleteAllItems()
{
	BOOL bResult = FALSE;

	EMULE_TRY

	sfl_itemdata *itemdata;
	for(int i=GetItemCount(); i>0; i--)
	{
		itemdata=(sfl_itemdata *)GetItemData(i-1);
		SetItemData(i-1, NULL);
		//DeleteItem(i-1);
		if(itemdata)
			delete itemdata;
	}
	bResult = CListCtrl::DeleteAllItems();

	EMULE_CATCH

	return bResult;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSharedFilesCtrl::OnContextMenu(CWnd* pWnd, CPoint point)
{
	EMULE_TRY

	if (m_pSCM)
	{
		delete m_pSCM;
		m_pSCM = NULL;
	}

	sfl_itemdata	*itemdata;
	UINT			uFlag;
	CTitleMenu		m_SharedFilesMenu;
	CMenu			m_menuPriority;
	CMenu			m_PermMenu;
	CMenu			m_ed2kMenu;
	CMenu			m_ShellContextMenu;
	CMenu			m_menuWeb;

	m_SharedFilesMenu.CreatePopupMenu();
	m_SharedFilesMenu.AddMenuTitle(GetResString((m_allYaKnow) ? IDS_KNOWNFILES : IDS_SHAREDFILES));

	int				iSel = GetSelectionMark();

	if (iSel != -1)
		itemdata = reinterpret_cast<sfl_itemdata*>(GetItemData(iSel));

	UINT		dwSelectedCnt = GetSelectedCount();
	bool		bJustOne = (dwSelectedCnt == 1);
	bool		bNone = (dwSelectedCnt == 0);

	if (!bNone)
	{
		if (itemdata->isFile)
		{
		//	Add priority switcher
			m_menuPriority.CreateMenu();

			bool		bTmpFlag = (bJustOne && !itemdata->knownFile->IsULAutoPrioritized());
			bool		bIsJumpStart = (itemdata->knownFile->GetJumpstartEnabled());

			m_menuPriority.AppendMenu( MF_STRING |
				((bTmpFlag && itemdata->knownFile->GetULPriority() == PR_VERYLOW) ? MF_CHECKED : MF_UNCHECKED),
				MP_PRIOVERYLOW, GetResString(IDS_PRIOVERYLOW) );
			m_menuPriority.AppendMenu( MF_STRING |
				((bTmpFlag && itemdata->knownFile->GetULPriority() == PR_LOW) ? MF_CHECKED : MF_UNCHECKED),
				MP_PRIOLOW, GetResString(IDS_PRIOLOW) );
			m_menuPriority.AppendMenu( MF_STRING |
				((bTmpFlag && itemdata->knownFile->GetULPriority() == PR_NORMAL) ? MF_CHECKED : MF_UNCHECKED),
				MP_PRIONORMAL, GetResString(IDS_PRIONORMAL) );
			m_menuPriority.AppendMenu( MF_STRING |
				((bTmpFlag && itemdata->knownFile->GetULPriority() == PR_HIGH) ? MF_CHECKED : MF_UNCHECKED),
				MP_PRIOHIGH, GetResString(IDS_PRIOHIGH) );
			m_menuPriority.AppendMenu( MF_STRING |
				((bTmpFlag && itemdata->knownFile->GetULPriority() == PR_RELEASE) ? MF_CHECKED : MF_UNCHECKED),
				MP_PRIORELEASE, GetResString(IDS_PRIORELEASE) );
			m_menuPriority.AppendMenu( MF_STRING |
				((bJustOne && itemdata->knownFile->IsULAutoPrioritized()) ? MF_CHECKED : MF_UNCHECKED),
				MP_PRIOAUTO, GetResString(IDS_PRIOAUTO) );

			if ( ( !itemdata->knownFile->IsPartFile() && !m_allYaKnow &&
				((itemdata->knownFile->GetFileSize() > PARTSIZE) || bIsJumpStart) ) ||	//don't allow to enable JumpStart for small files
				(bIsJumpStart && m_allYaKnow) )
			{
				m_menuPriority.AppendMenu(MF_SEPARATOR);
				m_menuPriority.AppendMenu(MF_STRING | (bIsJumpStart ? MF_CHECKED : MF_UNCHECKED), MP_JUMPSTART, _T("JumpStart"));
			}
			m_SharedFilesMenu.AppendMenu(MF_STRING|MF_POPUP|MF_ENABLED,(UINT_PTR)m_menuPriority.m_hMenu, GetResString(IDS_PRIORITY));

		//	add permission switcher
			m_PermMenu.CreateMenu();
			m_PermMenu.AppendMenu(MF_STRING | 
				((bJustOne && itemdata->knownFile->GetPermissions() == PERM_NOONE) ? MF_CHECKED : MF_UNCHECKED),
				MP_PERMNONE, GetResString(IDS_HIDDEN));
			m_PermMenu.AppendMenu(MF_STRING | 
				((bJustOne && itemdata->knownFile->GetPermissions() == PERM_FRIENDS) ? MF_CHECKED : MF_UNCHECKED),
				MP_PERMFRIENDS, GetResString(IDS_FSTATUS_FRIENDSONLY));
			m_PermMenu.AppendMenu(MF_STRING | 
				((bJustOne && itemdata->knownFile->GetPermissions() == PERM_ALL) ? MF_CHECKED : MF_UNCHECKED),
				MP_PERMALL, GetResString(IDS_FSTATUS_PUBLIC));

			m_SharedFilesMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_PermMenu.m_hMenu, GetResString(IDS_PERMISSION));
			m_SharedFilesMenu.AppendMenu(MF_SEPARATOR);

			if (m_allYaKnow == false)
			{
				m_ShellContextMenu.CreateMenu();
				uFlag = MF_STRING | MF_GRAYED;
				if (bJustOne && !itemdata->knownFile->IsPartFile())
				{
					uFlag &= ~MF_GRAYED;

					CString	strBuffer = ConcatFullPath(itemdata->knownFile->GetPath(), itemdata->knownFile->GetFileName());

					m_pSCM = new CShellContextMenu(m_hWnd, strBuffer);
					m_pSCM->SetMenu(&m_ShellContextMenu);
				}
				m_SharedFilesMenu.AppendMenu(uFlag | MF_POPUP, (UINT_PTR)m_ShellContextMenu.m_hMenu, GetResString(IDS_SHELLCONTEXT));
				m_SharedFilesMenu.AppendMenu( MF_STRING |
					((itemdata->knownFile->IsPartFile() || !(bJustOne)) ? MF_GRAYED : MF_ENABLED),
					MP_OPENFOLDER, GetResString(IDS_OPENFOLDER) + GetStringFromShortcutCode(IndexShOpenFolder, SSP_TAB_PREFIX) );

				m_SharedFilesMenu.AppendMenu( MF_STRING |
					((itemdata->knownFile->IsPartFile() || !g_eMuleApp.m_pGlobPrefs->IsAVEnabled() || (g_eMuleApp.m_pGlobPrefs->GetAVPath().IsEmpty())) ? MF_GRAYED : MF_ENABLED),
					MP_AV_SCAN, GetResString(IDS_AV_SCAN));
			}
			m_SharedFilesMenu.AppendMenu( MF_STRING |
				((bJustOne) ? MF_ENABLED : MF_GRAYED) |
				((itemdata->knownFile->GetFileComment().IsEmpty()) ? MF_UNCHECKED : MF_CHECKED),
				MP_CMT, GetResString(IDS_CMT_ADD) + GetStringFromShortcutCode(IndexShComments, SSP_TAB_PREFIX) );
			m_SharedFilesMenu.AppendMenu(MF_STRING | ((bJustOne) ? MF_ENABLED : MF_GRAYED), MP_FAKE_REPORT, GetResString(IDS_FAKE_REPORT));
		}
		else
		{
			uFlag = MF_STRING | (itemdata->knownFile->IsPartFile() ? MF_GRAYED : MF_ENABLED);

			m_SharedFilesMenu.AppendMenu(uFlag, MP_SFL_PARTON, GetResString(IDS_SF_PARTON));
			m_SharedFilesMenu.AppendMenu(uFlag, MP_SFL_PARTHIDDEN, GetResString(IDS_SF_PARTHIDDEN));
		}

		m_SharedFilesMenu.AppendMenu(MF_SEPARATOR);
		m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_CLEARALLSTATS, GetResString(IDS_SF_RESETALLSTATS));
		m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_CLEARSTATS, GetResString(IDS_SF_RESETSESSTATS));

		m_SharedFilesMenu.AppendMenu(MF_SEPARATOR);

	//	Delete is possible only for a known file
		if (m_allYaKnow && itemdata->isFile)
		{
			m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_DELKNOWN, GetResString(IDS_SF_DELETE));
			m_SharedFilesMenu.AppendMenu(MF_SEPARATOR);
		}
	}

	if(m_allYaKnow)
	{
		m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_MERGEKNOWN, GetResString(IDS_SF_MERGE));
		m_SharedFilesMenu.AppendMenu(MF_SEPARATOR);
		m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_ALLYAKNOW, GetResString(IDS_SF_SHOWALLSF));
	}
	else
		m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_ALLYAKNOW, GetResString(IDS_SF_SHOWALLKF));

	if (!bNone)
	{
		m_SharedFilesMenu.AppendMenu(MF_SEPARATOR);

	//	ED2K link can't be obtained for a part only for a file
		if (itemdata->isFile)
		{
			m_ed2kMenu.CreateMenu();
			m_ed2kMenu.AppendMenu(MF_STRING,MP_GETED2KLINK, GetResString(IDS_DL_LINK1) + GetStringFromShortcutCode(IndexShED2KLink, SSP_TAB_PREFIX));
			m_ed2kMenu.AppendMenu(MF_STRING,MP_GETHTMLED2KLINK, GetResString(IDS_DL_LINK2) + GetStringFromShortcutCode(IndexShED2kLinkHtml, SSP_TAB_PREFIX));
			m_ed2kMenu.AppendMenu(MF_STRING,MP_GETSOURCEED2KLINK, GetResString(IDS_CREATESOURCELINK) + GetStringFromShortcutCode(IndexShED2kLinkSource, SSP_TAB_PREFIX));
			m_SharedFilesMenu.AppendMenu(MF_STRING|MF_POPUP|MF_ENABLED,(UINT_PTR)m_ed2kMenu.m_hMenu, GetResString(IDS_ED2KLINKFIX));
		}

		int		counter;

		m_menuWeb.CreateMenu();
		UpdateURLMenu(m_menuWeb,counter);
		uFlag = ((counter == 0) ? MF_GRAYED : MF_STRING) | (bJustOne ? MF_ENABLED : MF_GRAYED);
		m_SharedFilesMenu.AppendMenu(uFlag|MF_POPUP,(UINT_PTR)m_menuWeb.m_hMenu, GetResString(IDS_WEBSERVICES));
	}

	m_SharedFilesMenu.TrackPopupMenuEx(TPM_LEFTALIGN |TPM_RIGHTBUTTON,point.x,point.y,this, NULL);

	if (m_pSCM)
	{
		m_pSCM->CleanUp();
	}

//	Menu objects are destroyed in their destructor

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CSharedFilesCtrl::OnWndMsg(UINT iMessage,WPARAM wParam, LPARAM lParam, LRESULT *pResult)
{
	BOOL		bHandled = FALSE;

	EMULE_TRY

	switch (iMessage)
	{
		case WM_SFL_UPDATEITEM:
		{
			CKnownFile		*pKnownFile = reinterpret_cast<CKnownFile*>(lParam);
			bool			bResort = static_cast<bool>(wParam);

			UpdateItem(pKnownFile,bResort);
			bHandled = true;
			break;
		}
	}

	EMULE_CATCH

	if (!bHandled)
	{
		bHandled = CMuleListCtrl::OnWndMsg(iMessage,wParam,lParam,pResult);
	}

	return bHandled;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CSharedFilesCtrl::OnCommand(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

//	Commands which don't depend on selection
	switch (wParam)
	{
		case MP_SFL_ALLYAKNOW:
		{
			if(m_allYaKnow)
				ShowFileList(g_eMuleApp.m_pSharedFilesList);
			else
				ShowKnownList();
			return true;
		}
		case MP_SFL_MERGEKNOWN:
		{
			SetRedraw(FALSE);
			g_eMuleApp.m_pKnownFilesList->merge();
			ShowKnownList();
			SetRedraw(TRUE);
			return true;
		}
	}

	int iSel = GetSelectionMark();
	if (iSel == -1)
		return false;

	sfl_itemdata   *itemdata = (sfl_itemdata*)GetItemData(iSel);
	CKnownFile	   *file = itemdata->knownFile;

	if (wParam >= MP_WEBURL && wParam <= MP_WEBURL + 64)
	{
		RunURL(file, g_eMuleApp.m_strWebServiceURLArray.GetAt(wParam - MP_WEBURL));
		return true;
	}

//	Multiple selections
	CString							strBuffer;
	UINT							selectedCount = GetSelectedCount();
	CArray<CKnownFile*,CKnownFile*>	selectedList;
	POSITION						pos = GetFirstSelectedItemPosition();

	while (pos)
	{
		int	iSel = GetNextSelectedItem(pos);

		itemdata = reinterpret_cast<sfl_itemdata*>(GetItemData(iSel));

		//--- file selection? ---
		if (itemdata && itemdata->isFile)
		{
			selectedList.Add(itemdata->knownFile);
		}
	}

	switch (wParam)
	{
		case MP_GETED2KLINK:
		{
			while (!selectedList.IsEmpty())
			{
				strBuffer += selectedList.ElementAt(0)->CreateED2kLink();
				selectedList.RemoveAt(0);
				if (!selectedList.IsEmpty())
					strBuffer += _T("\r\n");
			}
			g_eMuleApp.CopyTextToClipboard(strBuffer);
			break;
		}
		case MP_GETHTMLED2KLINK:
		{
			while (!selectedList.IsEmpty())
			{
				strBuffer += selectedList.ElementAt(0)->CreateHTMLED2kLink();
				selectedList.RemoveAt(0);
				if(!selectedList.IsEmpty())
					strBuffer += _T("\r\n");
			}
			g_eMuleApp.CopyTextToClipboard(strBuffer);
			break;
		}
		case MP_GETSOURCEED2KLINK:
		{
#ifdef OLD_SOCKETS_ENABLED
			if (g_eMuleApp.m_pServerConnect->IsConnected() || !g_eMuleApp.m_pServerConnect->IsLowID())
			{
				while (!selectedList.IsEmpty())
				{
					strBuffer += selectedList.ElementAt(0)->CreateED2kSourceLink();
					selectedList.RemoveAt(0);
					if(!selectedList.IsEmpty())
						strBuffer += _T("\r\n");
				}
				g_eMuleApp.CopyTextToClipboard(strBuffer);
			}
			else
#endif //OLD_SOCKETS_ENABLED
				AfxMessageBox(GetResString(IDS_SOURCELINKFAILED));
			break;
		}
		case MP_FAKE_REPORT:
		{
		/*
		//	KuSh: this code seems very strange, why breaking after the while and before doing the entire job ? ...
			if (selectedCount > 1)
			{
				POSITION	pos = this->GetFirstSelectedItemPosition();

				while (pos != NULL)
				{
					file = (CKnownFile*)this->GetItemData(GetNextSelectedItem(pos));
				}
				break;
			}
		*/
			RunURL(file, _T("http://donkeyfakes.gambri.net/report.php?link=ed2k://|file|#filename|#filesize|#hashid|/"));
			break;
		}
		case MP_OPENFOLDER:
		{
			ShellOpenFile(file->GetPath());
			break;
		}
		case MP_AV_SCAN:
		{
			strBuffer = g_eMuleApp.m_pGlobPrefs->GetAVParams();
			while (!selectedList.IsEmpty())
			{
				if (!selectedList.ElementAt(0)->IsPartFile())
				{
					strBuffer += _T(" \"");
					strBuffer += ConcatFullPath(selectedList.ElementAt(0)->GetPath(), selectedList.ElementAt(0)->GetFileName());
					strBuffer += _T('\"');
				}
				selectedList.RemoveAt(0);
			}
			ShellExecute(NULL, "open", g_eMuleApp.m_pGlobPrefs->GetAVPath(), strBuffer, NULL, SW_SHOW);
			break;
		}
		case MP_CMT:
		{
			if(selectedCount > 1)
				break;
			CCommentDialog dialog(file);
			dialog.DoModal();
			break;
		}
		case MP_SFL_DELKNOWN:
		{
			//--- TODO: ask if really delete ---
			while (!selectedList.IsEmpty())
			{
				CKnownFile		*pKnownFile = selectedList.ElementAt(0);

			//	Try to clear file from download list if it's where as complete file not to crash
			//	during download list update, because file object will be destroyed now.
				g_eMuleApp.m_pDownloadList->ClearCompleted(pKnownFile->GetFileHash());

				g_eMuleApp.m_pSharedFilesList->RemoveFile(pKnownFile);
				selectedList.RemoveAt(0);
			}
			break;
		}
		case MP_SFL_CLEARSTATS:
		case MP_SFL_CLEARALLSTATS:
		{
			//--- TODO: ask if really erase ---

			bool			all = (wParam == MP_SFL_CLEARALLSTATS);
			CKnownFile	   *lastfile = NULL;

			POSITION		pos = GetFirstSelectedItemPosition();

			while (pos)
			{
				int	iSel = GetNextSelectedItem(pos);

				itemdata = (sfl_itemdata*)GetItemData(iSel);
				file = itemdata->knownFile;

				//--- file selection? ---
				if (itemdata->isFile)
					itemdata->knownFile->statistic.resetStats(all);
				//--- part selection ---
				else
					itemdata->knownFile->statistic.resetPartTraffic(itemdata->part, all);

				if (file != lastfile)
				{
					if (lastfile)
						UpdateItem(lastfile, false);
					lastfile = file;
				}
			}

			if (lastfile)
				UpdateItem(lastfile, true);
			RedrawItems(0, GetItemCount());
			break;
		}
		case MP_PRIOVERYLOW:
		case MP_PRIOLOW:
		case MP_PRIONORMAL:
		case MP_PRIOHIGH:
		case MP_PRIORELEASE:
		case MP_PRIOAUTO:
		{
			POSITION	pos = GetFirstSelectedItemPosition();

			while (pos != NULL)
			{
				int	iSel = this->GetNextSelectedItem(pos);

				itemdata = (sfl_itemdata*)GetItemData(iSel);
				file = itemdata->knownFile;

				//--- is there a part in selection? ---
				if (itemdata->isFile)
				{
					file->SetAutoULPriority(false);

					switch (wParam)
					{
						default:
						case MP_PRIOVERYLOW:
							file->SetULPriority(PR_VERYLOW);
							break;

						case MP_PRIOLOW:
							file->SetULPriority(PR_LOW);
							break;

						case MP_PRIONORMAL:
							file->SetULPriority(PR_NORMAL);
							break;

						case MP_PRIOHIGH:
							file->SetULPriority(PR_HIGH);
							break;

						case MP_PRIORELEASE:
							file->SetULPriority(PR_RELEASE);
							break;

						case MP_PRIOAUTO:
							file->SetAutoULPriority(true);
							file->UpdateUploadAutoPriority();
							break;
					}
					SetItemText(iSel, SFL_COLUMN_PRIORITY, GetKnownFilePriorityString(file));
				}
			}
			break;
		}
		case MP_SFL_PARTON:
		case MP_SFL_PARTHIDDEN:
		{
			POSITION	pos = GetFirstSelectedItemPosition();
			bool			bIsItemsUpdated = false;

			while (pos)
			{
				int	iSel = GetNextSelectedItem(pos);

				itemdata = reinterpret_cast<sfl_itemdata*>(GetItemData(iSel));
				if (itemdata)
				{
					file = itemdata->knownFile;
					if (itemdata->isFile == false)
					{
						if (file->IsPartFile() == false)
						{
							switch(wParam)
							{
								case MP_SFL_PARTON:
									file->SharePart(itemdata->part);
									SetItemText(iSel, SFL_COLUMN_PRIORITY, _T(""));
									bIsItemsUpdated = true;
									break;

								case MP_SFL_PARTHIDDEN:
									file->UnsharePart(itemdata->part);
									SetItemText(iSel, SFL_COLUMN_PRIORITY, GetResString(IDS_HIDDEN));
									bIsItemsUpdated = true;
									break;
							}
						}
					}
				}
			}

			if (bIsItemsUpdated)
				RedrawItems(0, GetItemCount());
			break;
		}
		case MP_PERMNONE:
		case MP_PERMFRIENDS:
		case MP_PERMALL:
		{
			POSITION	pos = GetFirstSelectedItemPosition();

			while (pos != NULL)
			{
				int	iSel = this->GetNextSelectedItem(pos);

				itemdata = (sfl_itemdata*)GetItemData(iSel);
				if (itemdata->isFile)
				{
					file = itemdata->knownFile;
					switch (wParam)
					{
						case MP_PERMNONE:
							file->SetPermissions(PERM_NOONE);
							break;

						case MP_PERMFRIENDS:
							file->SetPermissions(PERM_FRIENDS);
							break;

						case MP_PERMALL:
							file->SetPermissions(PERM_ALL);
							break;
					}
					SetItemText(iSel, SFL_COLUMN_PERMISSION, file->GetPermissionString());
				}
			}
			break;
		}
		case MP_JUMPSTART:
		{
			BOOL alreadyasked = FALSE;
			BOOL alreadynotified = FALSE;
			INT msgyes = 0;
			POSITION pos = GetFirstSelectedItemPosition();
			while(pos != NULL)
			{
				int		iSel = this->GetNextSelectedItem(pos);

				itemdata=reinterpret_cast<sfl_itemdata*>(GetItemData(iSel));
				file=itemdata->knownFile;

				//--- is there a part in selection? ---
				if(itemdata->isFile && !itemdata->knownFile->IsPartFile())
				{
					if(file->GetJumpstartEnabled())
					{
						if(alreadyasked != TRUE)
						{
							msgyes = AfxMessageBox(GetResString(IDS_JS_DISABLE), MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON2);
							alreadyasked = TRUE;
						}

						if(msgyes == IDYES)
						{
							file->SetJumpstartEnabled(false);
							SetItemText(iSel, SFL_COLUMN_PRIORITY, GetKnownFilePriorityString(file));
						}
					}
					else if (file->GetFileSize() > PARTSIZE)	//don't allow to enable JumpStart for small files
					{
						if (file->IsJsComplete())
						{
							if (alreadynotified != TRUE)
							{
								AfxMessageBox(GetResString(IDS_JS_COMPLETE), MB_OK|MB_ICONSTOP);
								alreadynotified = TRUE;
							}
						}
						else
						{
							file->SetJumpstartEnabled(true);
							SetItemText(iSel, SFL_COLUMN_PRIORITY, GetKnownFilePriorityString(file));
						}
					}
				}
			}
			break;
		}
		default:
		{
			if(m_pSCM)
				if(m_pSCM->IsMenuCommand(wParam))
					m_pSCM->InvokeCommand(wParam, file);
			break;
		}
	}

	return true;

	EMULE_CATCH

	return false;
}

void CSharedFilesCtrl::OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult)
{
	EMULE_TRY

	NMLISTVIEW* pNMListView = (NMLISTVIEW*)pNMHDR;
	m_listSorter.clicked(pNMListView->iSubItem);
	SetSortArrow(pNMListView->iSubItem, m_listSorter.arrow());

	m_sortParts=GetAsyncKeyState(VK_SHIFT) < 0;

	SortItems(SortProc, (LPARAM)&m_listSorter);
	g_eMuleApp.m_pGlobPrefs->SetColumnSortItem(CPreferences::TABLE_SHARED, pNMListView->iSubItem);
	g_eMuleApp.m_pGlobPrefs->SetColumnSortAscending(CPreferences::TABLE_SHARED, m_listSorter.dir());
	*pResult = 0;

	EMULE_CATCH
}

int CSharedFilesCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	//--- it happens :( ---
	if (lParam1 == NULL || lParam2 == NULL || lParamSort == NULL)
		return 0;

	EMULE_TRY

	CListCtrlSorter*	listSorter=(CListCtrlSorter*)lParamSort;
	int					tmp;
	sfl_itemdata*		item1;
	sfl_itemdata*		item2;

	if (listSorter->dir())
	{
		item1 = (sfl_itemdata*)lParam1;
		item2 = (sfl_itemdata*)lParam2;
	}
	else
	{
		item1 = (sfl_itemdata*)lParam2;
		item2 = (sfl_itemdata*)lParam1;
	}

	CKnownFile* knownfile1=item1->knownFile;
	CKnownFile* knownfile2=item2->knownFile;

	//--- it happens :( ---
	if (knownfile1 == NULL || knownfile2 == NULL)
		return 0;

	//--- some parts to compare? and from same file ---
	if (item1->isFile == false && item2->isFile == false && item1->knownFile == item2->knownFile)
	{
		//--- shiftkey down ---
		if (g_eMuleApp.m_pGlobPrefs->DoUsePT() && m_sortParts)		//Cax2 bugfix 09/01/03
		{
			switch(listSorter->level())
			{
				case 1:
					switch(listSorter->selected())
					{
						case SFL_COLUMN_TRANSFERRED:
							{
								uint32 pt1=knownfile1->GetPartTraffic(item1->part, true);
								uint32 pt2=knownfile2->GetPartTraffic(item2->part, true);

								if(pt1==0 && pt2==0)
								{
									pt1=knownfile1->GetPartTraffic(item1->part);
									pt2=knownfile2->GetPartTraffic(item2->part);

									if(pt1==0 && pt2==0)
										return sortcmp(item1->part, item2->part);

									if(pt1==0)
										return listSorter->dir()?1:-1;

									if(pt2==0)
										return listSorter->dir()?-1:1;

									return sortcmp(pt1, pt2);
								}

								if(pt1==0)
									return listSorter->dir()?1:-1;

								if(pt2==0)
									return listSorter->dir()?-1:1;

								return sortcmp(pt1, pt2);
							}
							break;

						case SFL_COLUMN_PARTTRAFFIC:
						case SFL_COLUMN_UPLOADS:
							return sortcmp(knownfile1->statistic.GetCompletePartReleases(item1->part),
								       knownfile2->statistic.GetCompletePartReleases(item2->part));
							break;

						default:
							return sortcmp(item1->part, item2->part);
					}
					break;

				case 2:
					switch(listSorter->selected())
					{
						case SFL_COLUMN_TRANSFERRED:
							{
								uint32 pt1=knownfile1->GetPartTraffic(item1->part);
								uint32 pt2=knownfile2->GetPartTraffic(item2->part);

								if(pt1==0 && pt2==0)
									return sortcmp(item1->part, item2->part);

								if(pt1==0)
									return listSorter->dir()?1:-1;

								if(pt2==0)
									return listSorter->dir()?-1:1;

								return sortcmp(pt1, pt2);
							}
							break;

						case SFL_COLUMN_PARTTRAFFIC:
						case SFL_COLUMN_UPLOADS:
							{
								double d1=(double)knownfile1->GetPartTraffic(item1->part)/knownfile1->GetPartSize(item1->part);
								double d2=(double)knownfile2->GetPartTraffic(item2->part)/knownfile2->GetPartSize(item2->part);

								return sortcmp(d1, d2);
							}

						default:
								return sortcmp(item1->part, item2->part);
					}
					break;
			}
		}

		//--- no shift key down, no sorting ---
		else
		{
			if(listSorter->dir())
				return sortcmp(item1->part, item2->part);
			else
				return sortcmp(item2->part, item1->part);
		}
	}

	//--- some other compare ---
	else
	{
		switch(listSorter->level())
		{
			case 1:
				switch(listSorter->selected())
				{
					case SFL_COLUMN_FILENAME:
						return _tcsicmp(knownfile1->GetFileName(), knownfile2->GetFileName());

					case SFL_COLUMN_FILESIZE:
						return sortcmp(knownfile1->GetFileSize(), knownfile2->GetFileSize());

					case SFL_COLUMN_TYPE:
						return _tcsicmp(knownfile1->GetFileTypeString(true), knownfile2->GetFileTypeString(true));

					case SFL_COLUMN_PRIORITY:
						return sortcmp(m_p2p[knownfile1->GetULPriority()], m_p2p[knownfile2->GetULPriority()]);

					case SFL_COLUMN_PERMISSION:
						return sortcmp(knownfile1->GetPermissions(), knownfile2->GetPermissions());

					case SFL_COLUMN_FILEID:
						return memcmp(knownfile1->GetFileHash(), knownfile2->GetFileHash(), 16);

					case SFL_COLUMN_REQUESTS:
						tmp=sortcmp(knownfile1->statistic.GetRequests(), knownfile2->statistic.GetRequests());
						return (tmp!=0)?tmp:sortcmp(knownfile1->statistic.GetAllTimeRequests(), knownfile2->statistic.GetAllTimeRequests());

					case SFL_COLUMN_ACCEPTED:
						tmp=sortcmp(knownfile1->statistic.GetAccepts(), knownfile2->statistic.GetAccepts());
						return (tmp!=0)?tmp:sortcmp(knownfile1->statistic.GetAllTimeAccepts(), knownfile2->statistic.GetAllTimeAccepts());

					case SFL_COLUMN_TRANSFERRED:
						tmp=sortcmp(knownfile1->statistic.GetTransferred(), knownfile2->statistic.GetTransferred());
						return (tmp!=0)?tmp:sortcmp(knownfile1->statistic.GetAllTimeTransferred(), knownfile2->statistic.GetAllTimeTransferred());

					case SFL_COLUMN_COMPLETESRC:
						{
							double f1= CompleteSourcesCmpValue(knownfile1, false);
							double f2= CompleteSourcesCmpValue(knownfile2, false);
							return sortcmp(f1, f2);
						}
					case SFL_COLUMN_PARTTRAFFIC:
					case SFL_COLUMN_UPLOADS:
						{
							tmp=sortcmp(knownfile1->statistic.GetCompleteReleases(), knownfile2->statistic.GetCompleteReleases());
							if (tmp!=0) return tmp;

							double d1=(double)knownfile1->statistic.GetAllTimeTransferred()/knownfile1->GetFileSize();
							double d2=(double)knownfile2->statistic.GetAllTimeTransferred()/knownfile2->GetFileSize();
							return sortcmp(d1, d2);
						}
					case SFL_COLUMN_FOLDER:
						{
							return sortcmp(knownfile1->GetPath(), knownfile2->GetPath());
						}
				}

			case 2:
				switch(listSorter->selected())
				{
					case SFL_COLUMN_REQUESTS:
						return sortcmp(knownfile1->statistic.GetAllTimeRequests(), knownfile2->statistic.GetAllTimeRequests());

					case SFL_COLUMN_ACCEPTED:
						return sortcmp(knownfile1->statistic.GetAllTimeAccepts(), knownfile2->statistic.GetAllTimeAccepts());

					case SFL_COLUMN_TRANSFERRED:
						return sortcmp(knownfile1->statistic.GetAllTimeTransferred(), knownfile2->statistic.GetAllTimeTransferred());

					case SFL_COLUMN_COMPLETESRC:
						{
							double f1= CompleteSourcesCmpValue(knownfile1, true);
							double f2= CompleteSourcesCmpValue(knownfile2, true);
							return sortcmp(f1, f2);
						}

					case SFL_COLUMN_PARTTRAFFIC:
					case SFL_COLUMN_UPLOADS:
						{
							double d1=(double)knownfile1->statistic.GetAllTimeTransferred()/knownfile1->GetFileSize();
							double d2=(double)knownfile2->statistic.GetAllTimeTransferred()/knownfile2->GetFileSize();

							return sortcmp(d1, d2);
						}
				}
		}
	}

	EMULE_CATCH

	return 0;
}

void CSharedFilesCtrl::UpdateItem(CKnownFile* toupdate, bool resort)
{
	if (!::IsWindow(m_hWnd) || (toupdate == NULL))
		return;

	EMULE_TRY

	sfl_itemdata*	itemdata;
	for(int i=0; i<GetItemCount(); i++)
	{
		itemdata=(sfl_itemdata*)GetItemData(i);
		if(itemdata->isFile && itemdata->knownFile==toupdate)
		{
			UpdateFile(toupdate, i, resort);
			Update(i);
			return;
		}
	}

	EMULE_CATCH
}

void CSharedFilesCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	EMULE_TRY

	if (!lpDrawItemStruct->itemData)
		return;

	sfl_itemdata*	itemdata=(sfl_itemdata*)lpDrawItemStruct->itemData;
	CKnownFile*		file=itemdata->knownFile;
	CDC* odc = CDC::FromHandle(lpDrawItemStruct->hDC);
	int iODC = odc->SaveDC();
	UINT			iCalcFlag = (DT_SINGLELINE | DT_VCENTER | DT_NOPREFIX | DT_END_ELLIPSIS);

	if (IsRightToLeftLanguage())
		iCalcFlag |= DT_RTLREADING;

	if((lpDrawItemStruct->itemAction | ODA_SELECT) &&
		(lpDrawItemStruct->itemState & ODS_SELECTED))
	{
		if(GetFocus()==this)
			odc->SetBkColor(m_crHighlight);
		else
			odc->SetBkColor(m_crNoHighlight);
	}
	else
		odc->SetBkColor(GetBkColor());

	CMemDC dc(odc, &CRect(lpDrawItemStruct->rcItem));
	int iDC = dc.SaveDC();
	CFont	*oldFont=dc->SelectObject(GetFont());

	if(m_allYaKnow)
	{
		if(file->GetSharedFile() == false)
			dc->SetTextColor(::GetSysColor(COLOR_GRAYTEXT));
		else
			dc->SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));
	}
	else
	{
		int	iSysColor = COLOR_WINDOWTEXT;

		if (file->IsPartFile())
			iSysColor = COLOR_GRAYTEXT;
		else if (file->GetJumpstartEnabled())
			iSysColor = COLOR_HIGHLIGHT;

		dc->SetTextColor(::GetSysColor(iSysColor));
	}

	RECT cur_rec;

	cur_rec = lpDrawItemStruct->rcItem;

	CHeaderCtrl *pHeaderCtrl = GetHeaderCtrl();
	int iCount = pHeaderCtrl->GetItemCount();
	int iImage;

	//--- all 0.. columns ---
	for(int c = 0; c < iCount; c++)
	{
		//--- get real column, may its moved ---
		int cc = pHeaderCtrl->OrderToIndex(c);

		//--- if the column is hidden, dont do anything ---
		if(IsColumnHidden(cc))
			continue;

 		if(cc)
			cur_rec.left = cur_rec.right;
		cur_rec.right = cur_rec.left + GetColumnWidth(cc);
		cur_rec.left += 4;

		//--- is it a file? ---
		if(itemdata->isFile)
		{
			switch(cc)
			{
				case SFL_COLUMN_FILENAME:

					// File Type
					if (g_eMuleApp.m_pGlobPrefs->ShowFileTypeIcon())
					{
						iImage = g_eMuleApp.GetFileTypeSystemImageIdx(file->GetFileName());
						if (g_eMuleApp.GetSystemImageList() != NULL)
							::ImageList_Draw(g_eMuleApp.GetSystemImageList(), iImage, dc->GetSafeHdc(), cur_rec.left, cur_rec.top + 1, ILD_TRANSPARENT);
						cur_rec.left += 19;
					}
					// File Rating
					if (g_eMuleApp.m_pGlobPrefs->ShowRatingIcons())
					{
						int	iImgIdx = file->GetFileRating();

						if (file->GetFileComment().IsEmpty() && (iImgIdx == PF_RATING_NONE))
							iImgIdx = 6;
						m_imageList.Draw(dc, iImgIdx, CPoint(cur_rec.left - 4, cur_rec.top + 2), ILD_TRANSPARENT);

						cur_rec.left += 10;
					}

				case SFL_COLUMN_TYPE:
				case SFL_COLUMN_PRIORITY:
				case SFL_COLUMN_PERMISSION:
				case SFL_COLUMN_FILEID:
				case SFL_COLUMN_REQUESTS:
				case SFL_COLUMN_COMPLETESRC:
				case SFL_COLUMN_ACCEPTED:
				case SFL_COLUMN_TRANSFERRED:
				case SFL_COLUMN_UPLOADS:
				case SFL_COLUMN_FOLDER:
					dc->DrawText(GetItemText(lpDrawItemStruct->itemID, cc), -1, &cur_rec, DT_LEFT | iCalcFlag);
					break;

				case SFL_COLUMN_FILESIZE:
					dc->DrawText(GetItemText(lpDrawItemStruct->itemID, cc), -1, &cur_rec, DT_RIGHT | iCalcFlag);
					break;

				case SFL_COLUMN_PARTTRAFFIC:	//--- part traffic ---
					if (g_eMuleApp.m_pGlobPrefs->DoUsePT())
					{
						cur_rec.bottom--;
						cur_rec.top++;

						// added
						int iWidth = cur_rec.right - cur_rec.left-4;
						int iHeight = cur_rec.bottom - cur_rec.top;

						if (iWidth > 0)
						{
							//--- old bar draw ---
							cdcStatus.CreateCompatibleDC(&dc);

							//--- the bar is not initalized yet? ---
							if (status == (HBITMAP)NULL)
							{
								status.CreateCompatibleBitmap(&dc, iWidth, iHeight);
								m_statusWidth=iWidth;
							}
							else
							{
								//--- the we do it this way ---
								if(iWidth!=m_statusWidth)
								{
									status.DeleteObject();
									status.CreateCompatibleBitmap(&dc, iWidth, iHeight);
									m_statusWidth=iWidth;
								}
							}

							CBitmap *oldBitmap=cdcStatus.SelectObject(&status);

							RECT rec_status;
							rec_status.left = 0;
							rec_status.top = 0;
							rec_status.bottom = iHeight;
							rec_status.right = iWidth;
							if(DrawStatusBarFile(&cdcStatus, &rec_status, file->statistic))
								dc->BitBlt(cur_rec.left, cur_rec.top, iWidth, iHeight,  &cdcStatus, 0, 0, SRCCOPY);

							cdcStatus.SelectObject(oldBitmap);

							cdcStatus.DeleteDC();
						}

						//added end
						cur_rec.bottom++;
						cur_rec.top--;
					}
					break;
			}
		}

		//--- it is a part of a file ---
		else
		{
			switch(cc)
			{
				case SFL_COLUMN_FILENAME:
					dc->DrawText(GetItemText(lpDrawItemStruct->itemID, cc), -1, &cur_rec, DT_RIGHT | iCalcFlag);
					break;

				case SFL_COLUMN_FILESIZE:
				case SFL_COLUMN_PRIORITY:
				case SFL_COLUMN_ACCEPTED:
				case SFL_COLUMN_TRANSFERRED:
				case SFL_COLUMN_UPLOADS:
				case SFL_COLUMN_COMPLETESRC:
					dc->DrawText(GetItemText(lpDrawItemStruct->itemID, cc), -1, &cur_rec, /*DT_RIGHT*/DT_LEFT | iCalcFlag);
					break;

				case SFL_COLUMN_PARTTRAFFIC:	//--- part traffic ---
					if (g_eMuleApp.m_pGlobPrefs->DoUsePT())
					{
						cur_rec.bottom--;
						cur_rec.top++;

						int iWidth = cur_rec.right - cur_rec.left-4;
						int iHeight = cur_rec.bottom - cur_rec.top;

						if (iWidth > 0)
						{
							//--- old bar draw ---
							cdcStatus.CreateCompatibleDC(&dc);

							//--- the bar is not initalized yet? ---
							if (status == (HBITMAP)NULL)
							{
								status.CreateCompatibleBitmap(&dc, iWidth, iHeight);
								m_statusWidth=iWidth;
							}
							else
							{
								//--- the we do it this way ---
								if (iWidth != m_statusWidth)
								{
									status.DeleteObject();
									status.CreateCompatibleBitmap(&dc, iWidth, iHeight);
									m_statusWidth=iWidth;
								}
							}
							CBitmap *oldBitmap=cdcStatus.SelectObject(&status);

							RECT rec_status;
							rec_status.left = 0;
							rec_status.top = 0;
							rec_status.bottom = iHeight;
							rec_status.right = iWidth;
							if (DrawStatusBarPart(&cdcStatus, &rec_status, file->statistic, itemdata->part))
								dc->BitBlt(cur_rec.left, cur_rec.top, iWidth, iHeight, &cdcStatus, 0, 0, SRCCOPY);

							cdcStatus.SelectObject(oldBitmap);

							cdcStatus.DeleteDC();
						}

						cur_rec.bottom++;
						cur_rec.top--;
					}
					break;
			}
		}
	}

	//--- draw rectangle around selected item ---
	if(lpDrawItemStruct->itemState & ODS_FOCUS)
	{
		RECT focus_rec;
		focus_rec.top    = lpDrawItemStruct->rcItem.top;
		focus_rec.bottom = lpDrawItemStruct->rcItem.bottom;
		focus_rec.left   = lpDrawItemStruct->rcItem.left + 1;
		focus_rec.right  = lpDrawItemStruct->rcItem.right - 1;
		if(GetFocus()==this)
		{
			brush.CreateSolidBrush(m_crFocusLine);
			m_pOldBrush = dc->SelectObject(&brush);
			dc->FrameRect(&focus_rec, &brush);
			dc->SelectObject(m_pOldBrush);
		}
		else
		{
			m_pOldBrush = dc->SelectObject(&brush);
			brush.CreateSolidBrush(m_crNoFocusLine);
			dc->FrameRect(&focus_rec, &brush);
			dc->SelectObject(m_pOldBrush);
		}
		brush.DeleteObject();
	}

	dc->SelectObject(oldFont);
	dc.RestoreDC(iDC);
	odc->RestoreDC(iODC);

	EMULE_CATCH
}

bool CSharedFilesCtrl::DrawStatusBarFile(CDC* dc, RECT* rect, const CFileStatistic& statistic)
{
	EMULE_TRY

	int	available, use;
	available=use=(rect->right-rect->left+1);
	uint32	fs=statistic.fileParent->GetFileSize();
	if(fs<PARTSIZE)
		use=max(1, available*((double)fs/PARTSIZE));

	RECT r;
	r.top=rect->top;
	r.bottom=rect->bottom;
	r.left=rect->left;
	r.right=rect->right;

	if(available==use)
	{
		brush.CreateSolidBrush(RGB(0x00, 0x00, 0x00));
		dc->FillRect(rect, &brush);
		brush.DeleteObject();
	}
	else
	{
		r.right=r.left+use;
		brush.CreateSolidBrush(RGB(0x00, 0x00, 0x00));
		m_pOldBrush = dc->SelectObject(&brush);
		dc->FillRect(&r, &brush);
		dc->SelectObject(m_pOldBrush);
		brush.DeleteObject();

		r.left=r.right;
		r.right=available;
		brush.CreateSolidBrush(RGB(0xCC, 0xCC, 0xCC));
		m_pOldBrush = dc->SelectObject(&brush);
		dc->FillRect(&r, &brush);
		dc->SelectObject(m_pOldBrush);
		brush.DeleteObject();
	}

	double bpp=(double)fs/use;

	//--- traffigram? ---
	if(m_trafficgram)
	{
		if ((statistic.GetAllTimeTransferred() == 0) || (statistic.partTraffic == NULL))
			return true;

		TraffiGram(dc, rect, statistic, use, bpp);
	}
	//--- old boring bar style :) ---
	else
	{
		uint32	t;	// traffic

		for(int x = 0; x < use; x++)
		{
			bool	boh = !statistic.fileParent->IsPartShared(x*bpp/PARTSIZE);

			//--- draw alltime parttraffic bar? ---
			if(m_display_atpte)
			{
				t=statistic.fileParent->GetTrafficPart(x*bpp, (x+1)*bpp);
				if (t || boh)
				{
					pen.CreatePen(PS_SOLID, 0, GrayIt(boh, GetTrafficColor(t/bpp)));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_atpts);
					dc->LineTo(x, m_display_atpte);
					dc->SelectObject(pOldPen);
					pen.DeleteObject();
				}
			}

			//--- draw alltime blocktraffic bar? ---
			if(m_display_atbte)
			{
				t=statistic.fileParent->GetTrafficBlock(x*bpp, (x+1)*bpp);
				if (t || boh)
				{
					pen.CreatePen(PS_SOLID, 0, GrayIt(boh, GetTrafficColor(t/bpp)));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_atbts);
					dc->LineTo(x, m_display_atbte);
					dc->SelectObject(pOldPen);		// FoRcHa
					pen.DeleteObject();
				}
			}

			//--- draw session blocktraffic bar? ---
			if(m_display_sbte)
			{
				t=statistic.fileParent->GetTrafficBlock(x*bpp, (x+1)*bpp, true);
				if (t || boh)
				{
					pen.CreatePen(PS_SOLID, 0, GrayIt(boh, GetTrafficColor(t/bpp)));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_sbts);
					dc->LineTo(x, m_display_sbte);
					dc->SelectObject(pOldPen);		// FoRcHa
					pen.DeleteObject();
				}
			}
		}
	}

	return true;

	EMULE_CATCH

	return false;
}

bool CSharedFilesCtrl::DrawStatusBarPart(CDC* dc, RECT* rect, const CFileStatistic& statistic, uint16 part)
{
	EMULE_TRY

	uint32 ps=statistic.fileParent->GetPartSize(part);

	RECT r;
	r.top=rect->top;
	r.bottom=rect->bottom;
	r.left=rect->left;
	r.right=rect->right;

	int use=max(1, (int)(rect->right - rect->left + 1)*((double)ps/PARTSIZE));

	if(ps!=PARTSIZE)
	{
		r.right=r.left+use;
		brush.CreateSolidBrush(RGB(0x00, 0x00, 0x00));
		m_pOldBrush = dc->SelectObject(&brush);
		dc->FillRect(&r, &brush);
		dc->SelectObject(m_pOldBrush);
		brush.DeleteObject();

		r.left=r.right;
		r.right=rect->right;
		brush.CreateSolidBrush(RGB(0xCC, 0xCC, 0xCC));
		m_pOldBrush = dc->SelectObject(&brush);
		dc->FillRect(&r, &brush);
		dc->SelectObject(m_pOldBrush);
		brush.DeleteObject();
	}
	else
	{
		brush.CreateSolidBrush(RGB(0x00, 0x00, 0x00));
		m_pOldBrush = dc->SelectObject(&brush);
		dc->FillRect(rect, &brush);
		dc->SelectObject(m_pOldBrush);
		brush.DeleteObject();
	}

	if(statistic.partTraffic==NULL || statistic.partTraffic[part]==0)
		return true;

	uint32 start=part*PARTSIZE;
	double bpp=(double)ps/use;

	//--- traffigram? ---
	if(m_trafficgram)
	{
		TraffiGram(dc, rect, statistic, use, bpp, start);
	}

	//--- old boring bar style :) ---
	else
	{
		uint32 t;

		//--- draw alltime parttraffic bar? ---
		if(m_display_atpte)
		{
			t=statistic.fileParent->GetPartTraffic(part);
			if(t)
			{
				r.top=m_display_atpts;
				r.bottom=m_display_atpte;
				r.left=rect->left;
				r.right=rect->left+use;
				brush.CreateSolidBrush(GetTrafficColor(static_cast<double>(t)/ps));
				m_pOldBrush = dc->SelectObject(&brush);
				dc->FillRect(&r, &brush);
				dc->SelectObject(m_pOldBrush);
				brush.DeleteObject();
				r.bottom=rect->bottom;
			}
		}

		for(int x = 0; x < use; x++)
		{
			//--- draw alltime blocktraffic bar? ---
			if(m_display_atbte)
			{
				t=statistic.fileParent->GetTrafficBlock(start+x*bpp, start+(x+1)*bpp);
				if(t)
				{
					pen.CreatePen(PS_SOLID, 0, GetTrafficColor(t/bpp));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_atbts);
					dc->LineTo(x, m_display_atbte);
					dc->SelectObject(pOldPen);		// FoRcHa
					pen.DeleteObject();
				}
			}

			//--- draw session blocktraffic bar? ---
			if(m_display_sbte)
			{
				t=statistic.fileParent->GetTrafficBlock(start+x*bpp, start+(x+1)*bpp, true);
				if(t)
				{
					pen.CreatePen(PS_SOLID, 0, GetTrafficColor(t/bpp));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_sbts);
					dc->LineTo(x, m_display_sbte);
					dc->SelectObject(pOldPen);		// FoRcHa
					pen.DeleteObject();
				}
			}
		}
	}

	return true;

	EMULE_CATCH

	return false;
}

void CSharedFilesCtrl::OnDoubleClick(NMHDR* pNMHDR, LRESULT* pResult)
{
	EMULE_TRY

	NMITEMACTIVATE *i=(NMITEMACTIVATE*)pNMHDR;

	if(i->iItem == -1)
		return;

	//--- if shift+dblclk hide all no traffic parts ---
	bool	onlyWithTraffic=i->uKeyFlags & LVKF_SHIFT;
	bool	onlyWithSessionTraffic=i->uKeyFlags & LVKF_SHIFT && i->uKeyFlags & LVKF_CONTROL;

	//--- get data from double clicked item ---
	sfl_itemdata	*itemdataParent=(sfl_itemdata*)GetItemData(i->iItem);

	//--- is it a file? ---
	if(itemdataParent->isFile==false)
	{
		switch(i->iSubItem)
		{
			case SFL_COLUMN_PRIORITY:
				{
					//--- no blocking and hidding for partfiles! ---
					if(itemdataParent->knownFile->IsPartFile())
						break;

					if (itemdataParent->knownFile->IsPartShared(itemdataParent->part))
						itemdataParent->knownFile->UnsharePart(itemdataParent->part);
					else
						itemdataParent->knownFile->SharePart(itemdataParent->part);

					UpdateItem(itemdataParent->knownFile);
				}
				break;
		}
		return;
	}

	CKnownFile	*file=itemdataParent->knownFile;

	//--- toggle open ---
	itemdataParent->isOpen=!itemdataParent->isOpen;

	//--- is this file already open? ---
	//!!! ATTN i toggled isOpen already... you will not understand why I did this :) ---
	if(itemdataParent->isOpen==false)
	{
		SetRedraw(false);

		//--- delete all part-childs ---
		for(uint16 part=0; part<itemdataParent->parts; part++)
		{
			sfl_itemdata *itemdata=(sfl_itemdata*)GetItemData(i->iItem+1);
			if (itemdata->isFile) break;	//Cax2 14/01/03	bugfix
			SetItemData(i->iItem+1, NULL);
			DeleteItem(i->iItem+1);
			if(itemdata) delete itemdata;
		}

		SetRedraw(true);
	}

	//--- it is not open ---
	else
	{
		if(g_eMuleApp.m_pGlobPrefs->DoUsePT() && file->GetPartCount()>1)
		{
			CString	buffer;
			uint16	parts=0;

			SetRedraw(false);

			for(uint16 part=0; part<file->GetPartCount(); part++)
			{
				//--- no no traffic items? ---
				if(onlyWithTraffic && file->GetPartTraffic(part, onlyWithSessionTraffic)==0)
					continue;

				parts++;

				sfl_itemdata	*itemdata=new sfl_itemdata;
				itemdata->isFile=false;
				itemdata->isOpen=false;
				itemdata->knownFile=file;
				itemdata->part=part;
				itemdata->parts=0;

				buffer.Format(_T("%i"), part);
				InsertItem(LVIF_TEXT|LVIF_PARAM, i->iItem+parts, buffer, 0, 0, 0, (LPARAM)itemdata);
			}

			SetRedraw(true);

			itemdataParent->parts=parts;

			//--- no parts added? then we can close it ---
			if(parts==0)
				itemdataParent->isOpen=false;

			//--- ok, thats why i toggled the isOpen before :) ---
			UpdateFile(file, i->iItem);
		}
	}

	*pResult=0;

	EMULE_CATCH
}

void CSharedFilesCtrl::OnNMClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY

	*pResult = 0;

	POSITION		posSelClient = GetFirstSelectedItemPosition();

	if (posSelClient == NULL)
		return;

	int				iItemIndex = GetNextSelectedItem(posSelClient);
	sfl_itemdata	*pItemDataParent = (sfl_itemdata*)GetItemData(iItemIndex);

	if (pItemDataParent == NULL)
		return;

	CKnownFile		*pKnownFile = pItemDataParent->knownFile;

	if (pKnownFile == NULL)
		return;

	g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.ShowDetails(pKnownFile);

	if (g_eMuleApp.m_pGlobPrefs->ShowRatingIcons())
	{
		DWORD		dwPos = GetMessagePos();
		CPoint		pt(LOWORD(dwPos), HIWORD(dwPos));
		CRect		rRect;

		ScreenToClient(&pt);
		GetItemRect(iItemIndex, &rRect, LVIR_BOUNDS);
		if (rRect.PtInRect(pt))
		{
			if (g_eMuleApp.m_pGlobPrefs->ShowFileTypeIcon())
				rRect.left += 19;

			CRect		rTestedArea(rRect.left + 3, rRect.top + 2, rRect.left + 11, rRect.top + 16);

			if (rTestedArea.PtInRect(pt))
			{
				CCommentDialog dialog(pKnownFile);
				dialog.DoModal();
			}
		}
	}

	EMULE_CATCH
}

void CSharedFilesCtrl::SetColoring(byte mode)
{
	EMULE_TRY

	switch(mode)
	{
	case 0:
		GetTrafficColor=&GetTrafficColor0;
		break;

	case 1:
		GetTrafficColor=&GetTrafficColor1;
		break;

	case 2:
		GetTrafficColor=&GetTrafficColor2;
		break;

	case 3:
		GetTrafficColor=&GetTrafficColor3;
		break;

	default:
		GetTrafficColor=&GetTrafficColor0;
	}

	EMULE_CATCH
}

void CSharedFilesCtrl::SetDisplay(byte mode, bool redraw)
{
	EMULE_TRY

	m_display=mode;

	//--- should be 17 pixel high, i hope that never changes, but i try to save cpu where i can ---

	switch(m_display)
	{
	case 1:
		m_display_atpts	= 0;
		m_display_atpte	= 4;
		m_display_atbts	= 5;
		m_display_atbte	= 16;
		m_display_sbts	= 0;
		m_display_sbte	= 0;
		m_trafficgram	= false;
		break;

	case 2:
		m_display_atpts	= 0;
		m_display_atpte	= 4;
		m_display_atbts	= 5;
		m_display_atbte	= 11;
		m_display_sbts	= 12;
		m_display_sbte	= 16;
		m_trafficgram	= false;
		break;

	case 3:	// traffigram
		m_trafficgram=true;
		break;

	case 0:
	default:
		m_display_atpts	= 0;
		m_display_atpte	= 16;
		m_display_atbts	= 0;
		m_display_atbte	= 0;
		m_display_sbts	= 0;
		m_display_sbte	= 0;

		m_trafficgram	= false;
	}

	if(redraw)
		RedrawItems(0, GetItemCount());

	EMULE_CATCH
}

void CSharedFilesCtrl::TraffiGram(CDC* dc, RECT* rect, const CFileStatistic& statistic, int use, double bpp, uint32 start)
{
	EMULE_TRY

	uint32 tt=0;
	//--- needs highest value! ---
	for(int x=0; x<use; x++)
	{
		tt=max(tt, statistic.fileParent->GetTrafficBlock(start+x*bpp, start+(x+1)*bpp));
	}

	int h=rect->bottom-rect->top+1;	// height
	int	lh=0;		// last height
	int	ch=0;		// current height
	uint32	lt=0;	// last traffic
	uint32	tph=tt/h;	// traffic per height pixel
	uint32	t;
	for(int x=0; x<use; x++)
	{
		t=statistic.fileParent->GetTrafficBlock(start+x*bpp, start+(x+1)*bpp);
		ch=h-static_cast<int>(h*static_cast<double>(t)/tt+0.5);
		if(t)
			dc->SetPixel(x, ch, GetTrafficColor(t/bpp));

		//--- fill space between last and now ---
		if(x && lh!=ch)
		{
			int d=1;
			if(lh>ch)
				d=-1;

			for(int i=1; i<abs(lh-ch)/2+1; i++)
			{
				dc->SetPixel(x-1,	lh+i*d, GetTrafficColor((tt-tph*(lh+i*d))/bpp));
				dc->SetPixel(x,		ch-i*d, GetTrafficColor((tt-tph*(ch-i*d))/bpp));
			}
		}

		lh=ch;
		lt=t;
	}

	EMULE_CATCH
}

COLORREF GetTrafficColor0(double f)
{
	//--- COLORING MODE 1 --- RAINBOW ---
	//--- 0..1   black to red ---
	if(f<1)
		return RGB((BYTE)(255*f), 0, 0);

	//--- 1..3   red to yellow ---
	if(f<3)
		return RGB(255, (byte)(255*(f-1)/2.0), 0);

	//--- 3..6   yellow to green ---
	if(f<6)
		return RGB((byte)(255*((6-f)/3.0)), 255, 0);

	//--- 6..10   green to cyan ---
	if(f<10)
		return RGB(0, 255, (byte)(255*((f-6)/4.0)));

	//--- 10..15   cyan to blue ---
	if(f<15)
		return RGB(0, (byte)(255*((15-f)/5.0)), 255);

	//--- 15..21   blue to pink ---
	if(f<21)
		return RGB((byte)(255*((f-15)/6.0)), 0, 255);

	//--- 21..28   pink to white ---
	if(f<28)
		return RGB(255, (byte)(255*((28-f)/7.0)), 255);

	return RGB(255, 255, 255);
}

COLORREF GetTrafficColor1(double f)
{
	//--- COLORING MODE 1 --- RAINBOW ---
	//--- 0..1   black to red ---
	if(f<1)
		return RGB((BYTE)(255*f), 0, 0);

	//--- 1..2   red to yellow ---
	if(f<2)
		return RGB(255, (byte)(255*(f-1)), 0);

	//--- 2..3   yellow to green ---
	if(f<3)
		return RGB((byte)(255*((3-f))), 255, 0);

	//--- 3..4   green to cyan ---
	if(f<4)
		return RGB(0, 255, (byte)(255*((f-3))));

	//--- 4..5   cyan to blue ---
	if(f<5)
		return RGB(0, (byte)(255*((5-f))), 255);

	//--- 5..6   blue to pink ---
	if(f<6)
		return RGB((byte)(255*((f-5))), 0, 255);

	//--- 6..7   pink to white ---
	if(f<7)
		return RGB(255, (byte)(255*((7-f))), 255);

	return RGB(255, 255, 255);
}

COLORREF GetTrafficColor2(double f)
{
	//--- COLORING MODE 2 --- like in download ---
	return RGB(0, (210-(22*(f-1)) <  0)? 0:210-(22*(f-1)), 255);
}

COLORREF GetTrafficColor3(double f)
{
	//--- girlie mode ---
	return RGB(255, 0, (210-(22*(f-1)) <  0)? 0:210-(22*(f-1)));
}

void CSharedFilesCtrl::ShowFilesCount()
{
	CString strCounter;

	if (!m_allYaKnow)
	{
		GetResString(&strCounter, IDS_SF_FILES);
		if (!g_eMuleApp.m_pSharedFilesList->m_waitingForHashList.IsEmpty())
			strCounter.AppendFormat(GetResString(IDS_STILLTOHASH), GetItemCount(), g_eMuleApp.m_pdlgEmule->m_iFilesToBeHashed);
		else
			strCounter.AppendFormat(_T(" (%u)"), GetItemCount());
	}
	else
		strCounter.Format(_T("%s (%u)"), GetResString(IDS_KNOWNFILES), GetItemCount());
	g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.SetDlgItemText(IDC_TRAFFIC_TEXT, strCounter);

	if (g_eMuleApp.m_pSharedFilesList->m_waitingForHashList.IsEmpty())
	{
		g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.GetDlgItem(IDC_RELOADSHAREDFILES)->EnableWindow(true);
	}
}

double CSharedFilesCtrl::CompleteSourcesCmpValue(CKnownFile* item, bool second)
{
	uint16 nCountLo, nCountHi;
	bool bPartFile= item->IsPartFile();

	if (bPartFile)
		((CPartFile*)item)->GetCompleteSourcesRange(&nCountLo, &nCountHi);
	else
		item->GetCompleteSourcesRange(&nCountLo, &nCountHi);

	return ((nCountLo == 0) ? ((nCountHi == 0) ? ((bPartFile) ? 2.0 : 0.0) : (2.0 - (1.0 / static_cast<double>(nCountHi)))) : (second) ? static_cast<double>(nCountHi) + 3.0 - (1.0 / static_cast<double>(nCountLo)) : static_cast<double>(nCountLo) + 3.0 - (1.0 / static_cast<double>(nCountHi)));
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSharedFilesCtrl::OnGetDispInfo(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);

	if (g_eMuleApp.m_pdlgEmule->IsRunning()){
		// Although we have an owner drawn listview control we store the text for the primary item in the listview, to be
		// capable of quick searching those items via the keyboard. Because our listview items may change their contents,
		// we do this via a text callback function. The listview control will send us the LVN_DISPINFO notification if
		// it needs to know the contents of the primary item.
		//
		// But, the listview control sends this notification all the time, even if we do not search for an item. At least
		// this notification is only sent for the visible items and not for all items in the list. Though, because this
		// function is invoked *very* often, no *NOT* put any time consuming code here in.

		if (pDispInfo->item.mask & (LVIF_TEXT | LVIF_PARAM)){
			sfl_itemdata* pData = reinterpret_cast<sfl_itemdata*>(pDispInfo->item.lParam);
			if(pData)
			{
				const CKnownFile* pFile = pData->knownFile;
				if (pFile != NULL){
					switch (pDispInfo->item.iSubItem){
						case 0:
							if (pDispInfo->item.cchTextMax > 0){
								_tcsncpy(pDispInfo->item.pszText, pFile->GetFileName(), pDispInfo->item.cchTextMax);
								pDispInfo->item.pszText[pDispInfo->item.cchTextMax-1] = _T('\0');
							}
							break;
						default:
							// shouldn't happen
							pDispInfo->item.pszText[0] = _T('\0');
							break;
					}
				}
			}
		}
	}
	*pResult = 0;
	EMULE_CATCH
}

BOOL CSharedFilesCtrl::PreTranslateMessage(MSG *pMsg)
{
	if ((pMsg->message == WM_KEYDOWN) || (pMsg->message == WM_SYSKEYDOWN))
	{
		int iMessage = 0;
		POSITION posSelClient = GetFirstSelectedItemPosition();

		if (posSelClient != NULL)
		{
			bool	bJustOne = (GetSelectedCount() == 1);
			short	nCode = GetCodeFromPressedKeys(pMsg);

			if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShOpenFolder))
			{
				sfl_itemdata *pItemData = reinterpret_cast<sfl_itemdata*>(GetItemData(GetNextSelectedItem(posSelClient)));

				if (!pItemData->knownFile->IsPartFile() && bJustOne)
					iMessage = MP_OPENFOLDER;
			}
			else if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShComments))
			{
				if (bJustOne)
					iMessage = MP_CMT;
			}
			else if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShED2KLink))
			{
				iMessage = MP_GETED2KLINK;
			}
			else if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShED2kLinkHtml))
			{
				iMessage = MP_GETHTMLED2KLINK;
			}
			else if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShED2kLinkSource))
			{
				iMessage = MP_GETSOURCEED2KLINK;
			}

			if (iMessage > 0)
			{
				PostMessage(WM_COMMAND, iMessage);
				return TRUE;
			}
		}
	}
	else if (pMsg->message == WM_MBUTTONUP)
	{
		POINT point;

		::GetCursorPos(&point);

		CPoint p = point;

		ScreenToClient(&p);

		int it = HitTest(p);

		if (it == -1)
			return false;

		sfl_itemdata   *itemdata = reinterpret_cast<sfl_itemdata*>(GetItemData(it));
		CKnownFile	   *pFile = itemdata->knownFile;

		if (pFile != NULL)
		{
			CCommentDialog dialog(pFile);
			dialog.DoModal();
			UpdateItem(pFile, false);
		}
		return true;
	}

	return CMuleListCtrl::PreTranslateMessage(pMsg);
}
